Package weka.classifiers

# Class ParallelIteratedSingleClassifierEnhancer

java.lang.Object
weka.classifiers.AbstractClassifier
weka.classifiers.SingleClassifierEnhancer
weka.classifiers.IteratedSingleClassifierEnhancer
weka.classifiers.ParallelIteratedSingleClassifierEnhancer

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `Classifier`, `BatchPredictor`, `CapabilitiesHandler`, `CapabilitiesIgnorer`, `CommandlineRunnable`, `OptionHandler`, `RevisionHandler`

Direct Known Subclasses:
  `RandomizableParallelIteratedSingleClassifierEnhancer`

public abstract class ParallelIteratedSingleClassifierEnhancer extends IteratedSingleClassifierEnhancer
Abstract utility class for handling settings common to meta classifiers that build an ensemble in parallel from a single base learner.

Version:
  $Revision: 11909 $
Author:
  Mark Hall (mhall{[at]}pentaho{[dot]}com), Bernhard Pfahringer (bernhard@waikato.ac.nz)
See Also:
  - Serialized Form

- ## Field Summary

  ### Fields inherited from class weka.classifiers.AbstractClassifier

  `BATCH_SIZE_DEFAULT, NUM_DECIMAL_PLACES_DEFAULT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ParallelIteratedSingleClassifierEnhancer()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `buildClassifier(Instances data)`
  Stump method for building the classifiers
  `int`
  `getNumExecutionSlots()`
  Get the number of execution slots (threads) to use for building the members of the ensemble.
  `String[]`
  `getOptions()`
  Gets the current settings of the classifier.
  `Enumeration<Option>`
  `listOptions()`
  Returns an enumeration describing the available options.
  `String`
  `numExecutionSlotsTipText()`
  Returns the tip text for this property
  `void`
  `setNumExecutionSlots(int numSlots)`
  Set the number of execution slots (threads) to use for building the members of the ensemble.
  `void`
  `setOptions(String[] options)`
  Parses a given list of options.

  ### Methods inherited from class weka.classifiers.IteratedSingleClassifierEnhancer

  `getNumIterations, numIterationsTipText, setNumIterations`

  ### Methods inherited from class weka.classifiers.SingleClassifierEnhancer

  `classifierTipText, getCapabilities, getClassifier, postExecution, preExecution, setClassifier`

  ### Methods inherited from class weka.classifiers.AbstractClassifier

  `batchSizeTipText, classifyInstance, debugTipText, distributionForInstance, distributionsForInstances, doNotCheckCapabilitiesTipText, forName, getBatchSize, getDebug, getDoNotCheckCapabilities, getNumDecimalPlaces, getRevision, implementsMoreEfficientBatchPrediction, makeCopies, makeCopy, numDecimalPlacesTipText, run, runClassifier, setBatchSize, setDebug, setDoNotCheckCapabilities, setNumDecimalPlaces`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ParallelIteratedSingleClassifierEnhancer

    public ParallelIteratedSingleClassifierEnhancer()

- ## Method Details

  - ### listOptions

    public Enumeration<Option> listOptions()
    Returns an enumeration describing the available options.
    Specified by:
      `listOptions` in interface `OptionHandler`
    Overrides:
      `listOptions` in class `IteratedSingleClassifierEnhancer`
    Returns:
      an enumeration of all the available options.

  - ### setOptions

    public void setOptions(String[] options) throws Exception
    Parses a given list of options. Valid options are:

    -num-slots num
    Set the number of execution slots to use (default 1 - i.e. no parallelism).

    Options after -- are passed to the designated classifier.

    Specified by:
      `setOptions` in interface `OptionHandler`
    Overrides:
      `setOptions` in class `IteratedSingleClassifierEnhancer`
    Parameters:
      `options` - the list of options as an array of strings
    Throws:
      `Exception` - if an option is not supported

  - ### getOptions

    public String[] getOptions()
    Gets the current settings of the classifier.
    Specified by:
      `getOptions` in interface `OptionHandler`
    Overrides:
      `getOptions` in class `IteratedSingleClassifierEnhancer`
    Returns:
      an array of strings suitable for passing to setOptions

  - ### setNumExecutionSlots

    public void setNumExecutionSlots(int numSlots)
    Set the number of execution slots (threads) to use for building the members of the ensemble.
    Parameters:
      `numSlots` - the number of slots to use.

  - ### getNumExecutionSlots

    public int getNumExecutionSlots()
    Get the number of execution slots (threads) to use for building the members of the ensemble.
    Returns:
      the number of slots to use

  - ### numExecutionSlotsTipText

    public String numExecutionSlotsTipText()
    Returns the tip text for this property
    Returns:
      tip text for this property suitable for displaying in the explorer/experimenter gui

  - ### buildClassifier

    public void buildClassifier(Instances data) throws Exception
    Stump method for building the classifiers
    Specified by:
      `buildClassifier` in interface `Classifier`
    Overrides:
      `buildClassifier` in class `IteratedSingleClassifierEnhancer`
    Parameters:
      `data` - the training data to be used for generating the ensemble
    Throws:
      `Exception` - if the classifier could not be built successfully